unit FHttpClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdSSLOpenSSLHeaders, StdCtrls;

type
  TFRMHttpClient = class(TForm)
    IdHTTP1: TIdHTTP;
    btnGoTo: TButton;
    txtURL: TEdit;
    cboOpenSSLAPI: TComboBox;
    Label1: TLabel;
    memoLog: TMemo;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    procedure btnGoToClick(Sender: TObject);
    procedure cboOpenSSLAPIChange(Sender: TObject);
    procedure IdSSLIOHandlerSocketOpenSSL1StatusInfo(const AMsg: String);
    procedure FormCreate(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  FRMHttpClient: TFRMHttpClient;

implementation



{$R *.dfm}

procedure TFRMHttpClient.btnGoToClick(Sender: TObject);
var
  oStream: TStringStream;
begin
  oStream := TStringStream.Create('');
  Try
    IdHTTP1.Get(txtURL.Text, oStream);
    btnGoTo.Enabled := False;
  Finally
    FreeAndNil(oStream);
  End;
end;

procedure TFRMHttpClient.cboOpenSSLAPIChange(Sender: TObject);
begin
  Case cboOpenSSLAPI.ItemIndex of
    0: IdSSLOpenSSLHeaders.OPENSSL_API_VERSION := opSSL_1_0;
    1: IdSSLOpenSSLHeaders.OPENSSL_API_VERSION := opSSL_1_1;
  end;
end;



procedure TFRMHttpClient.IdSSLIOHandlerSocketOpenSSL1StatusInfo(
  const AMsg: String);
begin
  if Assigned(memoLog) then
    memoLog.Lines.Add(AMsg);
end;

procedure TFRMHttpClient.FormCreate(Sender: TObject);
begin
  IdSSLOpenSSLHeaders.OPENSSL_API_VERSION := opSSL_1_1;
end;

end.
